# -*- perl -*-
use lib qw(t lib);
use strict;
use TestBackup;
use File::Backup qw(backup_numbered backup_auto);
    
plan test => 16;

makefile('a');

my $name = backup_auto('a');
ok($name, 'a~');
fileok('a', $name);

$name = backup_numbered('a');
ok($name, 'a.~1~');
fileok('a', $name);
    
$name = backup_auto('a');
ok($name, 'a.~2~');
fileok('a', $name);

mkdir "subdir";
$name = backup_auto('a', dir => 'subdir');
ok($name, File::Spec->catfile('subdir','a~'));
fileok('a', $name);

$name = backup_auto('a', dir => 'subdir');
ok($name, File::Spec->catfile('subdir','a~'));
fileok('a', $name);

ok(open(FH, '>', File::Spec->catfile('subdir','a.~1~')));
$name = backup_auto('a', dir => 'subdir');
ok($name, File::Spec->catfile('subdir','a.~2~'));
fileok('a', $name);

eval {
    backup_auto('a', dir => 'nonexisting');
};
ok(!!$@);

$name = backup_auto('a', dir => 'nonexisting', error => \my $err);
ok(!defined($name));
ok(defined($err) && $err ne '');
